﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.WindowsCE.Forms;

namespace HandleKeysTester
{
    public partial class Form1 : Form
    {
        Button currentFocusedButton = null;
        
        public Form1()
        {
            InitializeComponent();

            this.button1.GotFocus += new EventHandler(button_GotFocus);
            this.button2.GotFocus += new EventHandler(button_GotFocus);
            this.button3.GotFocus += new EventHandler(button_GotFocus);
        }

        void button_GotFocus(object sender, EventArgs e)
        {
            currentFocusedButton = (Button)sender;
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            if ((e.KeyCode == System.Windows.Forms.Keys.Up))
            {
                // Up
                FocusNextControl();
            }
            if ((e.KeyCode == System.Windows.Forms.Keys.Down))
            {
                // Down
                FocusNextControl();
            }
            if ((e.KeyCode == System.Windows.Forms.Keys.Enter))
            {
                // Enter
                SimulateButtonClick(currentFocusedButton);
            }

        }

        /// <summary>
        /// Simulates a user pressing a button by posting a 
        /// button-click message to the control
        /// </summary>
        /// <param name="button">Control to click</param>
        public void SimulateButtonClick(Control button)
        {
            // Windows Message for button click
	        const int BM_CLICK = 245;

	        Message msg = new Message();
	        msg.HWnd = button.Handle;
	        msg.Msg = BM_CLICK;
	        // Let the MessageWindow class do all the work
	        MessageWindow.PostMessage(ref msg);
        }

        private void FocusNextControl()
        {
            foreach (Control c in this.Controls)
            {
                if (c is Button)
                {
                    if (((Button)c).Focused)
                    {
                        continue;
                    }

                    ((Button)c).Focus();
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            System.Windows.Forms.MessageBox.Show("Button 1 Pressed");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            System.Windows.Forms.MessageBox.Show("Button 2 Pressed");
        }

        private void button3_Click(object sender, EventArgs e)
        {
            System.Windows.Forms.MessageBox.Show("Button 3 Pressed");
        }
    }
}